'use strict';

exports.__esModule = true;
exports.default = createHistoryListener;

var _pinkiePromise = require('pinkie-promise');

var _pinkiePromise2 = _interopRequireDefault(_pinkiePromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createHistoryListener(history) {
  var resolver = null;
  var initial = true;
  var initialLocation = void 0;

  if (typeof history.getCurrentLocation === 'function') {
    initialLocation = history.getCurrentLocation();
  } else {
    initialLocation = history.location;
  }

  history.listen(function (location) {
    if (!initialLocation) {
      initialLocation = location;
    } else if (resolver) {
      resolver(location);
      resolver = null;
    }
  });

  return function listen() {
    if (initial) {
      initial = false;
      return _pinkiePromise2.default.resolve(initialLocation);
    }

    return new _pinkiePromise2.default(function (resolve) {
      if (!resolver) {
        resolver = resolve;
      }
    });
  };
}