'use strict';

exports.__esModule = true;
exports.default = router;

var _effects = require('redux-saga/effects');

var _buildRouteMatcher = require('./buildRouteMatcher');

var _buildRouteMatcher2 = _interopRequireDefault(_buildRouteMatcher);

var _createHistoryListener = require('./createHistoryListener');

var _createHistoryListener2 = _interopRequireDefault(_createHistoryListener);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var STATE = {
  LISTEN: 0,
  HANDLE_LOCATION: 1
};

function padSlash(path) {
  if (path[0] !== '/') {
    return '/' + path;
  }

  return path;
}

function router(history, routes) {
  var listen = (0, _createHistoryListener2.default)(history);
  var routeMatcher = (0, _buildRouteMatcher2.default)(routes);

  var state = STATE.LISTEN;

  function listenValue() {
    var value = (0, _effects.call)(listen);

    state = STATE.HANDLE_LOCATION;

    return { value: value, done: false };
  }

  function handleLocationValue(location) {
    var path = padSlash(location.pathname);
    var match = routeMatcher.match(path);

    if (match) {
      var value = (0, _effects.call)(match.action, match.params);

      state = STATE.LISTEN;

      return { value: value, done: false };
    }

    return listenValue();
  }

  var iterator = {
    name: '',

    next: function next(location) {
      if (state === STATE.LISTEN) {
        return listenValue();
      }

      return handleLocationValue(location);
    },
    throw: function _throw() {},
    return: function _return() {}
  };

  if (typeof Symbol === 'function' && Symbol.iterator) {
    iterator[Symbol.iterator] = function () {
      return iterator;
    };
  }

  return iterator;
}